#include "stdio.h"
#include "string.h"
#include "asmlib.h"
#define   tam_linha   79


void token(char *inst,char *op1,char *op2,char *mnem, char *label);
int sym_table(char *label,char modo, int *nlabels, int loc_cnt, char *op1);
int op_table(char *mnem, char modo, char *op1, char *op2,int *bin);
void inhenche();

struct Tlabel {
  char nome[10];
  int end, valor;
}labels[100];

struct Toptable {
  char opcode[7];
} opcodes[135];

int main() {

  TOperacao *cOP;
  TOperando *cOp1, *cOp2;
  TOperacao Op;

  char inst[60], op1[7], op2[7],mnem[7], label[10];
  int bin[30], loc_cnt, op1i, op2i, i, nlabels;
  FILE *ptr;
  char nm_arq[10];
  char b;

  //b = '\n';
  //printf ("%d",b);

  nlabels= 0;
  printf ("\n\nDigite o nome do arquivo a ser carregado ->");
  gets (nm_arq); fflush (stdin);
  
  if ((ptr=fopen(nm_arq,"rt"))==NULL) {
    printf ("\n\n\tErro ao abrir o arquivo");
    printf ("\n\n");
    system("PAUSE");
    exit();
  }
                //PASSO 1

  inhenche();
  while (!feof(ptr)) {     //enquanto nao fim de arquivo

    fgets(inst,tam_linha,ptr);
    token(inst,op1,op2,mnem,label);
    strupr (op1); strupr (op2); strupr (mnem); strupr (label);
    if (!strcmp(mnem,"A"))  loc_cnt = atoi(op1);
    if (strcmp(label,"")) {           // se tiver label
      if (!strcmp(mnem,"WORD")||!strcmp(mnem,"BYTE") )  {
        sym_table(label,'v',&nlabels,loc_cnt,op1);
      }
      else {
        sym_table(label,'w',&nlabels,loc_cnt,op1);
      }
    }

    if (strcmp(mnem,"WORD") && strcmp(mnem,"BYTE") && strcmp(mnem,"A")) {      //se nao for uma diretiva
      if ((op_table(mnem,'p',op1,op2,bin))== 0) {
        printf ("\n\n OBS: Codigo de operacao nao encontrado"); system ("pause");
        exit ();
      }
      cOp1 = EncodeOperando(op1);
	  cOp2 = EncodeOperando(op2);
	  Op = GetOperation(mnem, cOp1, cOp2);
	  Op.Op1 = *cOp1;
      Op.Op2 = *cOp2;

      loc_cnt += Op.format.size;

    }
    else {   //se for uma diretiva
      op1i = atoi(op1);
      if (!strcmp(mnem,"RESB")) loc_cnt += op1i;
      if (!strcmp(mnem,"RESW")) loc_cnt += 2*op1i;
    }

   /* printf ("\n\n---> %s",label);
    printf ("\n\n---> %s",mnem);    //debug
    printf ("\n\n--->%s",op1);
    printf ("\n\n---> %s",op2);    system ("pause");    */

  }
  printf("\n\n-----tabela de simbolos---------");
    for (i=0; i<nlabels; i++)
    printf("\n%s         %d ",labels[i].nome,labels[i].end);

  fclose(ptr);


      system("pause");
}

void token (char *inst,char *op1,char *op2,char *mnem, char *label) {
  int i,j,k;

  strcpy(label,""); strcpy(op1,""); strcpy(op2,"");
  i= 0;
  while ((inst[i] != 58) && (inst[i] != 59) && (i < tam_linha)) i++;
  if ((i == tam_linha) ||(inst[i] == 59))  i=0; //A linha nao contem labels
  else {
    k=j= 0;
    while (inst[k]== 32) k++; //acha o comeco do label
    while (k < i) {
      label[j]= inst[k];   //copa o label
      j++; k++;
    }
    label[j]= NULL;    i++;
  }
  while (inst[i] == 32) i++;     //encontrara o comeo do mnemonico
  j=0;
  while (inst[i] != 32) {
    mnem[j]= inst[i];            //copia o mnemonico
    j++; i++;
  }
  mnem[j]= NULL;

  while ( (inst[i] == 32) && (i< tam_linha) && (inst[i] != 59) && (inst[i] != 10)) i++;
  if ((i == tam_linha) || (inst[i] == 59))  return;   //a funcao nao possui operando
  else {

    j=0;
    while ((inst[i] != 32) && (inst[i] != 44)) {
      op1[j]= inst[i];                   //copia o primeiro operando
      i++;  j++;
    }
    op1[j]= NULL;
  }
  while (((inst[i] == 32) || (inst[i] == 44)) && (i<tam_linha) && (inst[i] != 59)) i++;

  if ((i == tam_linha) || (inst[i] == 59)) return;  //a funcao tem apenas um operando
  else {
    j=0;
    while ((inst[i] != 32) && (inst[i] != 59) && (inst[i] != 10)) {
      op2[j]= inst[i];
      i++, j++;                            //copia o segundo operando
    }
    op2[j]= NULL;
  }
}


int sym_table(char *label,char modo, int *nlabels, int loc_cnt, char *op1) {
  int op1i, i;

  switch(modo)  {
    case 'w': {
      for (i=0; i<100; i++) {
        if (!strcmp(label,labels[i].nome)) {
          printf ("\n\n\tErro: Dupla declarao de rotulos\n");
          return 0;
        }
      }
      strcpy(labels[*nlabels].nome,label);
      labels[*nlabels].end = loc_cnt;
      *nlabels = *nlabels+1;
    } break;

    case 'v': {
      for (i=0; i<100; i++) {
        if (!strcmp(label,labels[i].nome)) {
          printf ("\n\n\tErro: Dupla declarao de variaveis\n");
          return 0;
        }
      }
      op1i = atoi(op1);
      strcpy(labels[*nlabels].nome,label);
      labels[*nlabels].end = loc_cnt;
      labels[*nlabels].valor = op1i;
      *nlabels = *nlabels+1;
    } break;

  }
}

int op_table(char *mnem, char modo, char *op1, char *op2,int *bin) {
  int i, d, w, mod[2];
  FILE ptr2;


  switch (modo) {

    case 'p': {
      for (i=0; i<121; i++)   if (!strcmp(opcodes[i].opcode,mnem)) return 1;
      return 0;
    } break;

  }



}

void inhenche() {  //COMPLETA NA RACA TOTAL UMA STRUCT COM TODOS OS NOMES DE OPREANDOS POSSVEIS
  strcpy(opcodes[0].opcode,"AAA");     strcpy(opcodes[42].opcode,"AAD");    strcpy(opcodes[84].opcode,"AAM");
  strcpy(opcodes[1].opcode,"AAS");     strcpy(opcodes[43].opcode,"ADC");    strcpy(opcodes[85].opcode,"ADD");
  strcpy(opcodes[2].opcode,"AND");     strcpy(opcodes[44].opcode,"CALL");   strcpy(opcodes[86].opcode,"CBW");
  strcpy(opcodes[3].opcode,"CLC");     strcpy(opcodes[45].opcode,"CLD");    strcpy(opcodes[87].opcode,"CLI");
  strcpy(opcodes[4].opcode,"CMC");     strcpy(opcodes[46].opcode,"CMP");    strcpy(opcodes[88].opcode,"CMPS");
  strcpy(opcodes[5].opcode,"CMPSB");   strcpy(opcodes[47].opcode,"CMPSW");
  strcpy(opcodes[6].opcode,"CWD");     strcpy(opcodes[48].opcode,"DAA");    strcpy(opcodes[89].opcode,"DAS");
  strcpy(opcodes[7].opcode,"DEC");     strcpy(opcodes[49].opcode,"DIV");    strcpy(opcodes[90].opcode,"ESC");
  strcpy(opcodes[8].opcode,"HLT");     strcpy(opcodes[50].opcode,"IDIV");   strcpy(opcodes[91].opcode,"IMUL");
  strcpy(opcodes[9].opcode,"IN");      strcpy(opcodes[51].opcode,"INC");    strcpy(opcodes[92].opcode,"INT");
  strcpy(opcodes[10].opcode,"INTO");   strcpy(opcodes[52].opcode,"IRET");   strcpy(opcodes[93].opcode,"JA");
  strcpy(opcodes[11].opcode,"JNBE");   strcpy(opcodes[53].opcode,"JAE");    strcpy(opcodes[94].opcode,"JNB");
  strcpy(opcodes[12].opcode,"JB");     strcpy(opcodes[54].opcode,"JNAE");   strcpy(opcodes[95].opcode,"JBE");
  strcpy(opcodes[13].opcode,"JNA");    strcpy(opcodes[55].opcode,"JCXZ");   strcpy(opcodes[96].opcode,"JE");
  strcpy(opcodes[14].opcode,"JZ");     strcpy(opcodes[56].opcode,"JG");     strcpy(opcodes[97].opcode,"JNLE");
  strcpy(opcodes[15].opcode,"JGE");    strcpy(opcodes[57].opcode,"JNL");    strcpy(opcodes[98].opcode,"JL");
  strcpy(opcodes[16].opcode,"JNGE");   strcpy(opcodes[58].opcode,"JLE");    strcpy(opcodes[99].opcode,"JNG");
  strcpy(opcodes[17].opcode,"JMP");    strcpy(opcodes[59].opcode,"JNE");    strcpy(opcodes[100].opcode,"JNZ");
  strcpy(opcodes[18].opcode,"JNO");    strcpy(opcodes[60].opcode,"JNP");    strcpy(opcodes[101].opcode,"JPO");
  strcpy(opcodes[19].opcode,"JNS");    strcpy(opcodes[61].opcode,"JO");     strcpy(opcodes[102].opcode,"JP");
  strcpy(opcodes[20].opcode,"JPE");    strcpy(opcodes[62].opcode,"JS");
  strcpy(opcodes[21].opcode,"JC");     strcpy(opcodes[63].opcode,"JNC");    strcpy(opcodes[103].opcode,"LAHF");
  strcpy(opcodes[22].opcode,"LDS");    strcpy(opcodes[64].opcode,"LEA");    strcpy(opcodes[104].opcode,"LES");
  strcpy(opcodes[23].opcode,"LOCK");   strcpy(opcodes[65].opcode,"LODS");
  strcpy(opcodes[24].opcode,"LODSB");  strcpy(opcodes[66].opcode,"LODSW");  strcpy(opcodes[105].opcode,"LOOP");
  strcpy(opcodes[25].opcode,"LOOPE");  strcpy(opcodes[67].opcode,"LOOPZ");  strcpy(opcodes[106].opcode,"LOOPNE");
  strcpy(opcodes[26].opcode,"LOOPNZ"); strcpy(opcodes[68].opcode,"MOV");    strcpy(opcodes[107].opcode,"MOVS");
  strcpy(opcodes[27].opcode,"MOVSB");  strcpy(opcodes[69].opcode,"MOVSW");
  strcpy(opcodes[28].opcode,"MUL");    strcpy(opcodes[70].opcode,"NEG");    strcpy(opcodes[108].opcode,"NOP");
  strcpy(opcodes[29].opcode,"NOT");    strcpy(opcodes[71].opcode,"OR");     strcpy(opcodes[109].opcode,"OUT");
  strcpy(opcodes[30].opcode,"POP");    strcpy(opcodes[72].opcode,"POPF");
  strcpy(opcodes[31].opcode,"PUSH");   strcpy(opcodes[73].opcode,"PUSHF");  strcpy(opcodes[110].opcode,"RCL");
  strcpy(opcodes[32].opcode,"RCR");    strcpy(opcodes[74].opcode,"REP");    strcpy(opcodes[111].opcode,"RET");
  strcpy(opcodes[33].opcode,"REPE");   strcpy(opcodes[75].opcode,"REPNE");  strcpy(opcodes[112].opcode,"REPNZ");
  strcpy(opcodes[34].opcode,"REPZ");   strcpy(opcodes[76].opcode,"ROL");    strcpy(opcodes[113].opcode,"ROR");
  strcpy(opcodes[35].opcode,"SAHF");   strcpy(opcodes[77].opcode,"SAL");    strcpy(opcodes[114].opcode,"SHL");
  strcpy(opcodes[36].opcode,"SAR");    strcpy(opcodes[78].opcode,"SBB");    strcpy(opcodes[115].opcode,"SACS");
  strcpy(opcodes[37].opcode,"SACSB");  strcpy(opcodes[79].opcode,"SACSW");  strcpy(opcodes[116].opcode,"SHR");
  strcpy(opcodes[38].opcode,"STC");    strcpy(opcodes[80].opcode,"STD");    strcpy(opcodes[117].opcode,"STI");
  strcpy(opcodes[39].opcode,"STOS");   strcpy(opcodes[81].opcode,"STOSB");  strcpy(opcodes[118].opcode,"STOSW");
  strcpy(opcodes[40].opcode,"SUB");    strcpy(opcodes[82].opcode,"TEST");   strcpy(opcodes[119].opcode,"WAIT");
  strcpy(opcodes[41].opcode,"XCHG");   strcpy(opcodes[83].opcode,"XLAT");   strcpy(opcodes[120].opcode,"XOR");

}
